QGIS Application - Bug report #16769

QGis server GetPrint request renders layer in wrong order, polygons are on top

2017-06-29 06:10 PM - lars Lingner

Status: Closed
Priority: High
Assignee: René-Luc RelLuc

Category: QGIS Server

Affected QGIS version:2.18.11

Operating System: Linux Mint 18.1 Serena / Ubuntu 16.04
Pull Request or Patch supplied:

Crashes QGIS or corrupls data:

Regression?:
Easy fix?:
Resolution:

Yes
No
fixed/implemented

Copied to github as #: 24668

Description

Hello,

I've setup a QGis Server 2.18.10 (wasn't available in Affected QGis Version on the submit form). Requesting via GetPrint and groupname

or map name the layer order isn't right, maybe reversed.

Export directly in QGis desktop and via WMS request is working properly.

| compared the QGis logfile for a request with group name and all layer names and it is the same. The layer names are in the right order, if

the order in the log is actually showing render order.

The getProjectSettings request is listing the layers also in the right order.

At the supplied archive you will find my test case, which includes
- point,line,multiline,polygon layer

- OSM source data

- GetProjectSettings.xml

Layer structure is:
Group: grundkarte
Layers: points,lines,multilines,polygons

I'm happy to help and test. Right now | don't know how, because the logfiles don't give me a clue.

History

#1 - 2017-06-29 06:21 PM - Giovanni Manghi
- Regression? changed from No to Yes
- Priority changed from Normal to High

#2 - 2017-08-06 03:30 PM - René-Luc ReLuc

Does your GetPrint request is build by QWC or Lizmap ?

In QGIS 2.18 compare to 2.14 the layer order has been changed in GetPrint request.

#3 - 2017-08-06 06:50 PM - Giovanni Manghi
- Status changed from Open to Feedback

#4 - 2017-08-08 02:01 PM - lars Lingner
René-Luc RelLuc wrote:

Does your GetPrint request is build by QWC or Lizmap ?

Actually, | wrote it by myself.

qgis_mapserv.fcgi?VERSION=1.3.0&MAP=/path/to/qgis-project.qgs&styles=&format=pdf&request=GetPrint&layers=grundkarte& SRS=EPSG%3A3857
transparent=true&service=WMS&map0:extent=790262,6573581,792161,6575585& DP1=300& TEMPLATE=xxx

This request, using only the group name, is rendering the layer in wrong order.

qgis_mapserv.fcgi?VERSION=1.3.0&MAP=/path/to/qgis-project.qgs&styles=&format=pdf&request=GetPrint&layers=polygons,multilines,lines,points&S
S=EPSG%3A3857&transparent=true&service=WMS&map0:extent=790262,6573581,792161,6575585&DPI=300& TEMPLATE=xxx

This request, using explicit layer names, is working fine.

If I reverse the layer names, the rendering is also reversed. IMHO everything ok. First layer is rendered first, following layers rendered on top of it.

In QGIS 2.18 compare to 2.14 the layer order has been changed in GetPrint request.

Right, but it would only affect requests without group names?

Update: I'm using now 2.18.11

#5 - 2017-08-10 03:08 PM - Michael Douchin

I confirm this behaviour, with QGIS Server 2.18.11. When calling a GetPrint request with a group name (containing several groups or layers), the rendering
of each layers of this group is reversed. For example, if you have

MyGroup
- polygon cities with only borders (no fill)
- contours lines

- dem raster
You see only the dem raster when you use Mygroup in the layers parameter of the getprint request
#6 - 2017-08-10 04:38 PM - Giovanni Manghi
- Status changed from Feedback to Open
- Affected QGIS version changed from 2.18.9to 2.18.11
#7 - 2017-09-11 01:48 PM - René-Luc RelLuc

- Assignee set to René-Luc ReLuc
- Pull Request or Patch supplied changed from No to Yes

PR submitted https://github.com/qgis/QGIS/pull/5168

Canyou testit ?
https://github.com/qgis/QGIS/pull/5168

#8 - 2017-09-12 03:03 PM - Michael Douchin

Just tested it : it works now like a charm.

Thanks

#9 - 2017-09-12 03:09 PM - René-Luc ReLuc

- Resolution set to fixed/implemented

#10 - 2017-09-12 03:10 PM - Giovanni Manghi
- Status changed from Open to Closed
